/*
** pork_events.h - event handler functions.
** Copyright (C) 2002-2003 Amber Adams <amber@ojnk.net>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
*/

#ifndef __PORK_EVENTS_H
#define __PORK_EVENTS_H

enum {
	EVENT_BUDDY_AWAY,
	EVENT_BUDDY_BACK,
	EVENT_BUDDY_IDLE,
	EVENT_BUDDY_SIGNOFF,
	EVENT_BUDDY_SIGNON,
	EVENT_BUDDY_UNIDLE,
	EVENT_QUIT,
	EVENT_RECV_AWAYMSG,
	EVENT_RECV_CHAT_INVITE,
	EVENT_RECV_CHAT_JOIN,
	EVENT_RECV_CHAT_LEAVE,
	EVENT_RECV_CHAT_MSG,
	EVENT_RECV_IM,
	EVENT_RECV_PROFILE,
	EVENT_RECV_SEARCH_RESULT,
	EVENT_RECV_WARN,
	EVENT_SEND_AWAY,
	EVENT_SEND_CHAT_INVITE,
	EVENT_SEND_CHAT_JOIN,
	EVENT_SEND_CHAT_LEAVE,
	EVENT_SEND_CHAT_MSG,
	EVENT_SEND_IDLE,
	EVENT_SEND_IM,
	EVENT_SEND_LINE,
	EVENT_SEND_PROFILE,
	EVENT_SEND_WARN,
	EVENT_SIGNOFF,
	EVENT_SIGNON,
	MAX_EVENT_TYPE
};

struct event_info {
	char *name;
	char *fmt;
};

struct event {
	dlist_t *e[MAX_EVENT_TYPE];
};

struct event_entry {
	char *command;
	bool quiet;
	u_int32_t refnum;
};

int do_event(struct event *events, u_int32_t e, ...);
int add_event(struct event *events, const char *event_type, char *args);
void print_event_type(struct event *events, u_int32_t e);
void list_events(struct event *events, const char *event_type);

int events_del_refnum(struct event *events, u_int32_t refnum);
int events_del_type(struct event *events, const char *type, const char *func);
void events_init(struct event *events);
void events_destroy(struct event *events);
void events_purge(struct event *events);

#endif
